<template>
<div>
  <base-dialog :show="!!error" title="An error occurred!" @close="handleError">
    <p>{{ error }}</p>
  </base-dialog>
  <section>
    <base-card>
      <header>
        <h2>Requests received</h2>
      </header>
      <base-spinner v-if="isLoading"></base-spinner>
      <ul v-else-if="hasRequest && !isLoading">
        <request-item
          v-for="req in reqs"
          :key="req.id"
          :email="req.userEmail"
          :message="req.message"
        ></request-item>
      </ul>
      <h3 v-else>You haven't receive any request yet!</h3>
    </base-card>
  </section>
</div>
</template>

<script>
import RequestItem from './RequestItem';

export default {
  name: 'RequestsReceived',
  components: {
    RequestItem,
  },

  data(){
    return {
      isLoading: false,
      error: null,
    };
  },
  created(){
    this.loadRequest();
  },
  methods:{
    async loadRequest(){
      this.isLoading = true
      try{
        await this.$store.dispatch('req/loadRequests')
      }catch(error){
        this.error = error.message || 'Something went wrong!';
      }
      this.isLoading = false;
    },
    handleError(){
      this.error = null;
    },
  },
  computed: {
    reqs(){
      return this.$store.getters['req/getRequests']
    },
    hasRequest(){
      return this.$store.getters['req/hasRequest']
    },
  },
};
</script>

<style scoped>
header {
  text-align: center;
}

ul {
  list-style: none;
  margin: 2rem auto;
  padding: 0;
  max-width: 30rem;
}

h3 {
  text-align: center;
}
</style>